#!/usr/bin/python
# coding: utf-8
# +-------------------------------------------------------------------
# | 宝塔Linux面板
# +-------------------------------------------------------------------
# | Copyright (c) 2015-2099 宝塔软件(http://bt.cn) All rights reserved.
# +-------------------------------------------------------------------
# | Author: 无依 
# +-------------------------------------------------------------------

#+--------------------------------------------------------------------
#|   宝塔第三方应用开发wdcp_bt
#+--------------------------------------------------------------------
import sys,os,json,time
import sqlite3
#设置运行目录
os.chdir("/www/server/panel")

#添加包引用位置并引用公共包
sys.path.append("class/")
import public
import panelSite
import database
import ftp
#from common import dict_obj
#get = dict_obj();


if __name__ != '__main__':
    from BTPanel import cache,session,redirect



class wdcp_bt_main:
    __plugin_path = "/www/server/panel/plugin/wdcp_bt/"
    __wdcp_path ="/www/wdlinux/wdcp/data/"
    #__wdcp_db_path="/www/server/panel/plugin/wdcp_bt/db"
    __wdcp2bt_log="/www/server/panel/plugin/wdcp_bt/log/"
    __config = None
    __DB_CONN = None


    def  __init__(self):
        self.__DB_FILE=self.__wdcp_path+'wdcpdb.db'
        if not os.path.exists(self.__wdcp2bt_log):
            os.system('mkdir -p ' + self.__wdcp2bt_log)
        self.__web_log=self.__wdcp2bt_log+'web.log'
        self.__mysql_log=self.__wdcp2bt_log+'mysql.log'
        self.__ftp_log=self.__wdcp2bt_log+'ftp.log'

    def _check(self,args):
        return True
    def index(self,args):
        return self.get_logs(args)


###
# site?action=AddSite
# webname: {"domain":"baidu.com1\r","domainlist":["baidu2.com\r","231.com"],"count":2}
# type: PHP
# port: 80
# ps: baidu_com1
# path: /www/wwwroot/baidu.com1
# type_id: 0
# version: 74
# ftp: false
# sql: false
# codeing: utf8
######
# /site?action=create_website_multiple
# create_type: txt
# websites_content: ["123.com1|/www/wwwroot/123.com1|0|0|0","123.com2|/www/wwwroot/123.com2|0|0|0","123.com3|/www/wwwroot/123.com3|0|0|0","123.com4,test123.com1|/www/wwwroot/123.com4|0|0|0"]
####
#{"status": true, "msg": "创建网站 [ 123.com1,123.com2,123.com3,123.com4 ] 成功", "error": {}, "success": {"123.com1": {"db_status": false, "ftp_status": false}, "123.com2": {"db_status": false, "ftp_status": false}, "123.com3": {"db_status": false, "ftp_status": false}, "123.com4": {"db_status": false, "ftp_status": false}}}
#

# sql: MySQL
# datauser: 12311123_com
# datapassword: J6wazmf6GbnbxLYr
#/database?action=AddDatabase
# name: 123123
# codeing: utf8
# db_user: 123123
# password: 7TnGc2wTMK6byk5c
# dtype: MySQL
# dataAccess: 127.0.0.1
# address: 127.0.0.1
# ps: 123123

# /ftp?action=AddUser
# ftp_username: west9991
# ftp_password: McfLatYhtLnXFEYp
# path: /www/wwwroot/west9991
# ps: west9991
# result = public.WriteFile(filename,f_body,mode='w+')

###

    def get_site(self,args):
        count = self.__M_s("select domain,domains,vhostdir,phps from wd_site")
        data=[]
        for row in count:
            domains=row[0]
            if row[1]!='':
                domains=row[0]+','+row[1]
            strweb='{}|{}|0|0|{}'.format(domains,row[2]+'/public_html',row[3].replace('.', ''))
            data.append(strweb)
        p_data=public.dict_obj()
        p_data.create_type='txt'
        p_data.websites_content=json.dumps(data)
        crt_web=panelSite.panelSite()
        res=crt_web.create_website_multiple(p_data)
        #{"status": true, "msg": "创建网站 [ wdcp1.com,wdcp2.com ] 成功", "error": {}, "success": {"wdcp1.com": {"db_status": false, "ftp_status": false}, "wdcp2.com": {"db_status": false, "ftp_status": false}}}
        #{"status": true, "msg": "创建网站 [  ] 成功", "error": {"wdcp1.com": "您添加的站点已存在!", "wdcp2.com": "您添加的站点已存在!"}, "success": {}}
        if res['status']:
            f_body=time.strftime("%Y-%m-%d %H:%M:%S", time.localtime())+'\n####################################################################\n'
            f_body+='msg:'+res['msg']+'\n'
            strstr='\n--------------------------------------------------------------------\n'
            for row in res['success']:
                strstr+=row+'<-------->站点创建成功！'+str(res['success'][row])+'\n'
            f_body+='success:'+strstr+'\n'
            strstr='\n--------------------------------------------------------------------\n'
            for row in res['error']:
                strstr+=row+'<-------->'+res['error'][row]+'\n'
            f_body+='error:'+strstr+'\n'
            #result = public.WriteFile(self.__web_log,f_body,mode='w+')
            self.write_log(self.__web_log,f_body)
        f_body = public.ReadFile(self.__web_log,mode='r')
        return f_body
    

        #print(result)
    def get_mysql(self,args):
        count = self.__M_s("select username,password,dbname,dbcharset,dbhost,note from wd_mysql")
        #/www/wdlinux/mysql/bin/mysqldump -uroot -p09bb5076 wdcp2_db > /www/server/panel/plugin/wdcp_bt/db/wdcp2_db.sql >>1.txt 2>&1
        crt_mysql=database.database()
        f_body=time.strftime("%Y-%m-%d %H:%M:%S", time.localtime())+'\n####################################################################\n'
        for row in count:
            p_data=public.dict_obj()
            p_data.name=row[2]
            p_data.codeing=row[3]
            p_data.db_user=row[0]
            p_data.password=row[1]
            p_data.dtype='MySQL'
            p_data.dataAccess='127.0.0.1'
            p_data.address='127.0.0.1'
            p_data.ps=row[5]
            #shell_str='/www/wdlinux/mysql/bin/mysqldump -uroot -p{} {} > {}/{}.sql'.format('123456',row[2],self.__wdcp_db_path,row[2])
            #msg=public.ExecShell(shell_str)
            res=crt_mysql.AddDatabase(p_data)
            #{"status": false, "msg": "数据库已存在!"}
            if res['status']:
                shell_str='cp -r -p /www/wdlinux/mysql/data/{}/*  /www/server/data/{}/'.format(row[2],row[2])
                msg=public.ExecShell(shell_str)
                f_body+='success:mysql - '+row[2]+'<-------->'+res['msg']+'\n'
            else:
                f_body+='error:mysql - '+row[2]+'<-------->'+res['msg']+'请人工处理\n'
            #msgs.append(msg)
            #return shell_str
        #result = public.WriteFile(self.__mysql_log,f_body,mode='w+')
        self.write_log(self.__mysql_log,f_body)
        f_body = public.ReadFile(self.__mysql_log,mode='r')
        return f_body 
    def get_ftp(self,args):
        count = self.__M_s("select username,password,dir,note from wd_ftp")
        f_body=time.strftime("%Y-%m-%d %H:%M:%S", time.localtime())+'\n####################################################################\n'
        crt_ftp=ftp.ftp()
        for row in count:
            p_data=public.dict_obj()
            p_data.ftp_username=row[0]
            p_data.ftp_password=row[1]
            p_data.path=row[2]+'/public_html'
            p_data.ps=row[3]
            res=crt_ftp.AddUser(p_data)
            if res['status']:
                f_body+='success:ftp - '+row[0]+'<-------->'+res['msg']+'\n'
            else:
                f_body+='error:ftp - '+row[0]+'<-------->'+res['msg']+'\n'
            #msgs.append(msg)
            #return shell_str
        #result = public.WriteFile(self.__ftp_log,f_body,mode='w+')
        self.write_log(self.__ftp_log,f_body)
        f_body = public.ReadFile(self.__ftp_log,mode='r')
        return f_body
    def removewdcp(self,args):
        shell_str='rm -rf /www/wdlinux/'
        result = public.ExecShell(shell_str)
        if not os.path.exists('/www/wdlinux/'):
            return {'status':1,'msg':'删除成功'}
        else:
            return {'status':2,'msg':'删除失败'}
            
    def write_log(self,path,f_body):
        with open(path,'a') as f:
            f.write(f_body)
    # 数据库连接
    def __GetConn(self):
        try:
            if self.__DB_CONN == None:
                self.__DB_CONN = sqlite3.connect(self.__DB_FILE)
                self.__DB_CONN.text_factory = str
        except Exception as ex:
            return "error: " + str(ex)
     #数据库 插入 更新 删除
    def __M_int_up_del(self,sql):
        self.__GetConn()
        S=self.__DB_CONN.cursor()
        S.execute(sql)
        self.__DB_CONN.commit()
        num=self.__DB_CONN.total_changes
        # self.__DB_CONN.close()
        return num
    # 数据库 查询
    def __M_s(self,sql):
        self.__GetConn()
        S=self.__DB_CONN.cursor()
        cursors = S.execute(sql)
        data=[]
        for row in cursors:
            data.append(row)
        # self.__DB_CONN.close()
        return data
    def __get_config(self,key=None,force=False):
        #判断是否从文件读取配置
        if not self.__config or force:
            config_file = self.__plugin_path + 'config.json'
            if not os.path.exists(config_file): return None
            f_body = public.ReadFile(config_file)
            if not f_body: return None
            self.__config = json.loads(f_body)

        #取指定配置项
        if key:
            if key in self.__config: return self.__config[key]
            return None
        return self.__config


    def __set_config(self,key=None,value=None):
        #是否需要初始化配置项
        if not self.__config: self.__config = {}

        #是否需要设置配置值
        if key:
            self.__config[key] = value

        #写入到配置文件
        config_file = self.__plugin_path + 'config.json'
        public.WriteFile(config_file,json.dumps(self.__config))
        return True

